<?php
// $Id: scrollable_content_style_plugin.inc,v 1.2 2010/02/28 10:26:52 goodman Exp $
/**
 * @file
 *  Provide the views scrollable plugin object with default options and form.
 */

/**
  * Implementation of views_plugin_style().
  */
class scrollable_content_style_plugin extends views_plugin_style {
  function option_definition() {
    $options = parent::option_definition();
    $options['auto'] = array('default' => TRUE);
    $options['size'] = array('default' => 1);
    $options['vertical'] = array('default' => FALSE);
    $options['loop'] = array('default' => TRUE);
    $options['interval'] = array('default' => 2000);
    $options['speed'] = array('default' => 400);
    $options['items'] = array('default' => 'items');

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['auto'] = array(
      '#type' => 'checkbox',
      '#title' => t('Auto sliding'),
      '#default_value' => $this->options['auto'],
      '#description' => t('Automatic sliding of content. <em>Note:</em> it has nothing to do with the number of results'),
    );
    $form['size'] = array(
      '#type' => 'select',
      '#title' => t('Size'),
      '#default_value' => $this->options['size'],
      '#description' => t('The number of visible items within the scrollable-enabled HTML element. <em>Note:</em> it has nothing to do with the number of results'),
      '#options' => drupal_map_assoc(range(1, 10)),
    );
    $form['vertical'] = array(
      '#type' => 'checkbox',
      '#title' => t('Vertical'),
      '#default_value' => $this->options['vertical'],
      '#description' => t('Whether items will be scrolled vertically. (If set to false, items will be scrolled horizontally.)'),
    );
    $form['interval'] = array(
      '#type' => 'select',
      '#title' => t('Interval'),
      '#default_value' => $this->options['interval'],
      '#description' => t('The time (in milliseconds) between automatic scrolling of items (one step forward). 0 to disable automatic scrolling.'),
      '#options' => drupal_map_assoc(array(300, 400, 500, 1000, 2000, 3000, 5000, 10000)),
    );
    $form['speed'] = array(
      '#type' => 'select',
      '#title' => t('Speed'),
      '#default_value' => $this->options['speed'],
      '#description' => t('The time (in milliseconds) of the scrolling animation.'),
      '#options' => drupal_map_assoc(array(100, 400, 500, 1000, 2000)),
    );
    $form['items'] = array(
      '#type' => 'textfield',
      '#title' => t('Items'),
      '#default_value' => $this->options['items'],
      '#size' => 15,
      '#description' => t('Selector for the element that contains the scrollable items. This must be located inside the parent scrollable-enabled HTML element. <em>Note:</em> if you have many Scrollable Content views you have to set different selector ID for each view, otherwise only one view will work.'),
    );
  }    
}